/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * 
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.    
 */

package org.apache.photark.security.utils;


public class Constants {

    public final static String USER_STORE = "userStore";
    public final static String MUTUALLY_EXCLUSIVE_LIST = "mutuallyExclusiveLists";

    public final static String DEFAULT_LISTS = "_default";
    public final static String BLOCKED_USER_LIST = "blockedUserList";
    public final static String UNREGISTERED_USER_LIST = "unRegisteredUserList";
    public final static String REGISTERED_USER_LIST = "registeredUserList";
    public final static String SUPER_ADMIN_LIST = "superAdminList";

    public final static String ALL_USERS = "allUsers";

    public final static String USER_LISTS = "userLists";

    public final static String SUPER_ADMIN = "SuperAdmin";
    public final static String GUEST = "Guest";
    public final static String USER_DISPLAY_NAME = "displayName";
    public final static String USER_EMAIL = "email";
    public final static String USER_REAL_NAME = "realName";
    public final static String USER_WEBSITE = "webSite";
    public final static String USER_ID = "userId";

    public final static String ALL_PERMISSIONS = "allPermissions";

    public final static String ALBUM_CREATE_PERMISSION = "createAlbum";
    public final static String USER_GROUP_CREATE_PERMISSION = "createUserGroup";
    public final static String ALBUM_VIEW_IMAGES_PERMISSION = "viewImages";
    public final static String ALBUM_ADD_IMAGES_PERMISSION = "addImages";
    public final static String ALBUM_DELETE_IMAGES_PERMISSION = "deleteImages";
    public final static String ALBUM_EDIT_ALBUM_DESCRIPTION_PERMISSION = "editAlbumDescription";
    public final static String PERMISSION_DESCRIPTION = "desc";

    public final static String ALL_ROLES = "roles";
    public final static String ROLE_PERMISSIONS = "permissions";
    public final static String ROLE_USER_GROUPS = "userGroups";
    public final static String ALL_USERS_VIEW_ROLE = "allUsersViewRole";

    public final static String ALL_GROUPS = "groups";
    public final static String GROUP_USERS = "users";
    public final static String GROUP_OWNER = "owner";

    public final static String ACCESS_LIST = "accessList";
    
    public final static String USER_NEED_TO_REGISTER = "toRegister";

}
